# -*- coding: utf-8 -*-
# (C) 2010, Ben "GreaseMonkey" Russell for Ludumdare #19.
# Licensed under GPLv3. See COPYING for details.

# Music compiler

import sys, struct

stream = []
unique = {}
lookup = {}
bestest = 0

fp = open(sys.argv[1], "rb")
fp.seek(0x40) # assume default pos and skip header 'cos I'm lazy
# let's read the stream.
q = ""
while True:
	v = ord(fp.read(1))
	if v == 0x50:
		q += fp.read(1)
	elif v == 0x63:
		stream.append(q)
		if q != "":
			if not q in unique:
				unique[q] = q
				lookup[q] = 1
			else:
				lookup[q] += 1
			
			if lookup[q] > bestest:
				bestest = lookup[q]
		
		q = ""
	elif v == 0x66:
		break
	else:
		raise Exception("we don't support packet %02X" % v)
fp.close()

print len(stream), len(unique)

tab = []
ridx = {}
for i in xrange(bestest,0,-1):
	for k in lookup:
		if lookup[k] == i:
			ridx[k] = len(tab)+1
			tab.append(k)


fp = open(sys.argv[2], "wb")
fp.write(struct.pack("<H",0))

for _ in tab:
	fp.write(struct.pack("<H",0))

tptrs = []
for q in tab:
	tptrs.append(fp.tell())
	fp.write(q.replace("\x40","\x00")+"\x40")
tptrs = [fp.tell()] + tptrs

for q in stream:
	if q == "":
		fp.write("\x01")
	else:
		v = ridx[q]
		assert v != 0
		if v <= 0x7F:
			fp.write(chr(v*2+1))
		else:
			fp.write(struct.pack("<H",v*2))
fp.write("\x02\xFF")
fp.seek(0)
for p in tptrs:
	fp.write(struct.pack("<H",p))

fp.close()

# integrity test
print "testing stream integrity"

xs = stream
ns = []
fp = open(sys.argv[2], "rb")
ps, = struct.unpack("<H",fp.read(2))
while True:
	fp.seek(ps)
	v = ord(fp.read(1))
	ps += 1
	q = ""
	#print ">>",v
	if v == 0x01:
		pass
	else:
		if (v & 0x01) != 0:
			v -= 1
		else:
			v = v + ord(fp.read(1))*256
			ps += 1
			#print ">>>",v
		
		if (v & 0xFF00) == 0xFF00:
			break
		
		fp.seek(v)
		fp.seek(struct.unpack("<H",fp.read(2))[0])
		while True:
			v = ord(fp.read(1))
			if v == 0x40:
				break
			q += chr(v)
	
	ns.append(q)
	#print len(ns),hex(ps)
	assert xs[:len(ns)] == ns
fp.close()
assert ns == xs
